<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>array-cb-methods</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
</head>
<body>
<p>JavaScript’s Map, Reduce, and Filter</p>
<p>In 2011, JavaScript introduced <code>map</code>, <code>reduce</code>, and <code>filter</code> as powerful alternatives when translating elements, finding cumulative values, or building subsets based on conditions. These methods help the developer manage less complexity, work without side effects, and often make code more readable.</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="cf">for</span>(<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> <span class="va">array</span>.<span class="at">length</span><span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-2" title="2">    <span class="cf">if</span>(<span class="va">array</span>.<span class="at">indexOf</span>(array[i]) <span class="op">===</span> i) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-3" title="3">        <span class="va">models</span>.<span class="at">push</span>(array[i])<span class="op">;</span></a>
<a class="sourceLine" id="cb1-4" title="4">    <span class="op">}</span></a>
<a class="sourceLine" id="cb1-5" title="5"><span class="op">}</span></a></code></pre></div>
<p>We can see it traverses an array and inserts non-duplicate elements into a new array. But to figure this out we had to glean these 5 things.</p>
<table>
<colgroup>
<col style="width: 19%" />
<col style="width: 80%" />
</colgroup>
<thead>
<tr class="header">
<th>code piece</th>
<th>meaning</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td><code>let i = 0</code></td>
<td>starts at left side of array</td>
</tr>
<tr class="even">
<td><code>i &lt; array.length</code></td>
<td>finishes at right side of array</td>
</tr>
<tr class="odd">
<td><code>i++</code></td>
<td>increments by one</td>
</tr>
<tr class="even">
<td><code>array.indexOf(array[i]) === i</code></td>
<td>if value is first instance in array, it’ll match index. okay this means it’s checking if it’s a duplicate</td>
</tr>
<tr class="odd">
<td><code>models.push(...)</code></td>
<td><code>models</code> must be a list. But what data’s in it? What are their data types? I must search the file for “models”. Rinse. Repeat.</td>
</tr>
</tbody>
</table>
<p>We needed to check 5 pieces of information to determine what was going on. And this is a single <code>for</code> loop!</p>
<h1 id="a-functional-approach">A Functional Approach</h1>
<p>This same effect could be written using JavaScript’s built-in <code>filter()</code> method.</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">let</span> uniqueProducts <span class="op">=</span> <span class="va">array</span>.<span class="at">filter</span>(<span class="kw">function</span>(elem<span class="op">,</span> i<span class="op">,</span> array) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-2" title="2">        <span class="cf">return</span> <span class="va">array</span>.<span class="at">indexOf</span>(elem) <span class="op">===</span> i<span class="op">;</span></a>
<a class="sourceLine" id="cb2-3" title="3">    <span class="op">}</span></a>
<a class="sourceLine" id="cb2-4" title="4">)<span class="op">;</span></a></code></pre></div>
<p>Simple and elegant.</p>
<p>Seeing <code>filter</code> communicates code behavior so I know exactly what it’s doing. Compared to the looping approach above:</p>
<ul>
<li>Checking #1, #2, #3 is unnecessary because <code>filter()</code> does these automatically.</li>
<li>#4 is the same but without the additional <code>if(...)</code> block.</li>
<li>A big hurdle was #5. I had to search thru the code base to find what <code>models</code> even was. Did it already have data? Was it targeting specific data types? <code>map</code>, <code>reduce</code>, and <code>filter</code> solves this problem by not depending on code outside the callbacks, called side-effects.</li>
</ul>
<p>In sum, <code>map</code>, <code>reduce</code> and <code>filter</code> makes code less complex, without side effects, and often more readable.</p>
<p>Let’s look at each.</p>
<h1 id="map">map()</h1>
<p><strong>Use it when</strong>: You want to translate/map all elements in an array to another set of values.</p>
<p>Example: convert Fahrenheit temps to Celsius.</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">let</span> fahrenheit <span class="op">=</span> [<span class="dv">0</span><span class="op">,</span> <span class="dv">32</span><span class="op">,</span> <span class="dv">45</span><span class="op">,</span> <span class="dv">50</span><span class="op">,</span> <span class="dv">75</span><span class="op">,</span> <span class="dv">80</span><span class="op">,</span> <span class="dv">99</span><span class="op">,</span> <span class="dv">120</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb3-2" title="2"></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="kw">let</span> celcius <span class="op">=</span> <span class="va">fahrenheit</span>.<span class="at">map</span>(<span class="kw">function</span>(elem) <span class="op">{</span></a>
<a class="sourceLine" id="cb3-4" title="4">    <span class="cf">return</span> <span class="va">Math</span>.<span class="at">round</span>((elem <span class="op">-</span> <span class="dv">32</span>) <span class="op">*</span> <span class="dv">5</span> / <span class="dv">9</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-5" title="5"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-6" title="6"></a>
<a class="sourceLine" id="cb3-7" title="7"><span class="co">// ES6</span></a>
<a class="sourceLine" id="cb3-8" title="8"><span class="co">// fahrenheit.map(elem =&gt; Math.round((elem - 32) * 5 / 9));</span></a>
<a class="sourceLine" id="cb3-9" title="9"></a>
<a class="sourceLine" id="cb3-10" title="10">celcius <span class="co">//  [-18, 0, 7, 10, 24, 27, 37, 49]</span></a></code></pre></div>
<p><strong>What it does</strong>: Traverses the array from left to right invoking a callback function on each element with parameters (below). For each callback the value returned becomes the element in the new array. After all elements have been traversed map() returns the new array with all the translated elements[1].</p>
<p><strong>parameters</strong>:</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="va">array</span>.<span class="at">map</span>(<span class="kw">function</span>(elem<span class="op">,</span> index<span class="op">,</span> array) <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">      ...</a>
<a class="sourceLine" id="cb4-3" title="3"><span class="op">},</span> thisArg)<span class="op">;</span></a></code></pre></div>
<table>
<thead>
<tr class="header">
<th>param</th>
<th>meaning</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>elem</td>
<td>element value</td>
</tr>
<tr class="even">
<td>index</td>
<td>index in each traversal, moving from left to right</td>
</tr>
<tr class="odd">
<td>array</td>
<td>original array invoking the method</td>
</tr>
<tr class="even">
<td>thisArg</td>
<td>(Optional) object that will be referred to as <code>this</code> in callback</td>
</tr>
</tbody>
</table>
<h1 id="filter">filter()</h1>
<p><strong>Use it when</strong>: You want to remove unwanted elements based on a condition.</p>
<p>Example: remove duplicate elements from an array.</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">let</span> uniqueArray <span class="op">=</span> <span class="va">array</span>.<span class="at">filter</span>(<span class="kw">function</span>(elem<span class="op">,</span> index<span class="op">,</span> array) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">        <span class="cf">return</span> <span class="va">array</span>.<span class="at">indexOf</span>(elem) <span class="op">===</span> index<span class="op">;</span></a>
<a class="sourceLine" id="cb5-3" title="3">    <span class="op">}</span></a>
<a class="sourceLine" id="cb5-4" title="4">)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-5" title="5"></a>
<a class="sourceLine" id="cb5-6" title="6"><span class="co">// ES6</span></a>
<a class="sourceLine" id="cb5-7" title="7"><span class="co">// array.filter((elem, index, arr) =&gt; arr.indexOf(elem) === index);</span></a></code></pre></div>
<p><strong>What it does</strong>: Like <code>map()</code> it traverses the array from left to right invoking a callback function on each element. The returned value must be a boolean identifying whether the element will be kept or discarded. After all elements have been traversed <code>filter()</code> returns a new array with all elements that returned true[2].</p>
<p>It has the same parameters as <code>map()</code></p>
<p><strong>parameters</strong>:</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="va">array</span>.<span class="at">filter</span>(<span class="kw">function</span>(elem<span class="op">,</span> index<span class="op">,</span> array) <span class="op">{</span></a>
<a class="sourceLine" id="cb6-2" title="2">      ...</a>
<a class="sourceLine" id="cb6-3" title="3"><span class="op">},</span> thisArg)<span class="op">;</span></a></code></pre></div>
<table>
<thead>
<tr class="header">
<th>param</th>
<th>meaning</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>elem</td>
<td>element value</td>
</tr>
<tr class="even">
<td>index</td>
<td>index in each traversal, moving from left to right</td>
</tr>
<tr class="odd">
<td>array</td>
<td>original array invoking the method</td>
</tr>
<tr class="even">
<td>thisArg</td>
<td>(Optional) object that will be referred to as <code>this</code> in callback</td>
</tr>
</tbody>
</table>
<h1 id="reduce">reduce()</h1>
<p><strong>Use it when</strong>: You want to find a cumulative or concatenated value based on elements across the array.</p>
<p>Example: Sum up orbital rocket launches in 2014.</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="kw">let</span> rockets <span class="op">=</span> [</a>
<a class="sourceLine" id="cb7-2" title="2">    <span class="op">{</span> <span class="dt">country</span><span class="op">:</span><span class="st">&#39;Russia&#39;</span><span class="op">,</span> <span class="dt">launches</span><span class="op">:</span><span class="dv">32</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb7-3" title="3">    <span class="op">{</span> <span class="dt">country</span><span class="op">:</span><span class="st">&#39;US&#39;</span><span class="op">,</span> <span class="dt">launches</span><span class="op">:</span><span class="dv">23</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb7-4" title="4">    <span class="op">{</span> <span class="dt">country</span><span class="op">:</span><span class="st">&#39;China&#39;</span><span class="op">,</span> <span class="dt">launches</span><span class="op">:</span><span class="dv">16</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb7-5" title="5">    <span class="op">{</span> <span class="dt">country</span><span class="op">:</span><span class="st">&#39;Europe(ESA)&#39;</span><span class="op">,</span> <span class="dt">launches</span><span class="op">:</span><span class="dv">7</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb7-6" title="6">    <span class="op">{</span> <span class="dt">country</span><span class="op">:</span><span class="st">&#39;India&#39;</span><span class="op">,</span> <span class="dt">launches</span><span class="op">:</span><span class="dv">4</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb7-7" title="7">    <span class="op">{</span> <span class="dt">country</span><span class="op">:</span><span class="st">&#39;Japan&#39;</span><span class="op">,</span> <span class="dt">launches</span><span class="op">:</span><span class="dv">3</span> <span class="op">}</span></a>
<a class="sourceLine" id="cb7-8" title="8">]<span class="op">;</span></a>
<a class="sourceLine" id="cb7-9" title="9"></a>
<a class="sourceLine" id="cb7-10" title="10"><span class="kw">let</span> sum <span class="op">=</span> <span class="va">rockets</span>.<span class="at">reduce</span>(<span class="kw">function</span>(prevVal<span class="op">,</span> elem) <span class="op">{</span></a>
<a class="sourceLine" id="cb7-11" title="11">    <span class="cf">return</span> prevVal <span class="op">+</span> <span class="va">elem</span>.<span class="at">launches</span><span class="op">;</span></a>
<a class="sourceLine" id="cb7-12" title="12"><span class="op">},</span> <span class="dv">0</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-13" title="13"></a>
<a class="sourceLine" id="cb7-14" title="14"><span class="co">// ES6</span></a>
<a class="sourceLine" id="cb7-15" title="15"><span class="co">// rockets.reduce((prevVal, elem) =&gt; prevVal + elem.launches, 0);</span></a>
<a class="sourceLine" id="cb7-16" title="16"></a>
<a class="sourceLine" id="cb7-17" title="17">sum <span class="co">// 85</span></a></code></pre></div>
<p><strong>What it does</strong>: Like <code>map()</code> it traverses the array from left to right invoking a callback function on each element. The value returned is the cumulative value passed from callback to callback. After all elements have been traversed <code>reduce()</code> returns the cumulative value[3].</p>
<p><strong>parameters</strong>:</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="va">array</span>.<span class="at">reduce</span>(<span class="kw">function</span>(prevVal<span class="op">,</span> elem<span class="op">,</span> index<span class="op">,</span> array) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-2" title="2">      ...</a>
<a class="sourceLine" id="cb8-3" title="3"><span class="op">},</span> initialValue)<span class="op">;</span></a></code></pre></div>
<table>
<colgroup>
<col style="width: 13%" />
<col style="width: 86%" />
</colgroup>
<thead>
<tr class="header">
<th>param</th>
<th>meaning</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>prevValue</td>
<td>cumulative value returned thru each callback</td>
</tr>
<tr class="even">
<td>elem</td>
<td>element value</td>
</tr>
<tr class="odd">
<td>index</td>
<td>index of the traversal, moving from left to right</td>
</tr>
<tr class="even">
<td>array</td>
<td>original array invoking the method</td>
</tr>
<tr class="odd">
<td>initialValue</td>
<td>(Optional) object used as first argument in the first (leftmost) callback.</td>
</tr>
</tbody>
</table>
<h1 id="misc">Misc</h1>
<ul>
<li>Each are methods on the Array’s prototype object.</li>
<li>Changing an element in the <code>array</code> parameter in any callback will persist across all remaining callbacks but has no effect on the returned array.</li>
<li>Callback functions are invoked on indexes with any value, even <code>undefined</code>, but not ones deleted or never assigned a value.</li>
</ul>
<p>It’s worth noting <code>for</code> loops still definitely have a place when working with large arrays (e.g. over 1,000 elements) or needing to break the traversal if a condition is met.</p>
</body>
</html>
